'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

var _echarts = require('echarts');

var _echarts2 = _interopRequireDefault(_echarts);

var _elementResizeEvent = require('element-resize-event');

var _elementResizeEvent2 = _interopRequireDefault(_elementResizeEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by liekkas on 16/2/19.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var ECharts = function (_React$Component) {
  _inherits(ECharts, _React$Component);

  function ECharts(props) {
    _classCallCheck(this, ECharts);

    var _this = _possibleConstructorReturn(this, (ECharts.__proto__ || Object.getPrototypeOf(ECharts)).call(this, props));

    _this.state = {
      needInit: false //是否需要初始化,第一次创建或者主题发生变化需要init
    };
    return _this;
  }

  _createClass(ECharts, [{
    key: 'renderChart',
    value: function renderChart() {
      var _props = this.props,
          option = _props.option,
          notMerge = _props.notMerge,
          lazyUpdate = _props.lazyUpdate,
          config = _props.config;

      var chartDom = this.chart;
      var theme = config && config.theme || 'default';

      var chart = _echarts2.default.getInstanceByDom(chartDom);
      if (!chart || this.state.needInit) {
        chart = _echarts2.default.init(chartDom, theme);
        (0, _elementResizeEvent2.default)(chartDom, function () {
          chart.resize();
        });
        this.charts = chart;
      }

      if (config && config.hasOwnProperty('event')) {
        config.event.map(function (_ref) {
          var type = _ref.type,
              handler = _ref.handler;
          return chart.on(type, handler);
        });
      }

      if (config && config.showLoading) {
        chart.showLoading('default', config && config.loadingOption || {
          text: '加载中...',
          color: '#c23531',
          textColor: '#000',
          maskColor: 'rgba(255, 255, 255, 0.8)',
          zlevel: 0
        });
      } else {
        chart.hideLoading();
        chart.setOption(option, notMerge, lazyUpdate);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderChart();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderChart();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      //如果主题切换,需要重新创建实例,因为ECharts的主题设置api在init中,
      if (this.props.config.theme !== nextProps.config.theme) {
        this.setState({ needInit: true });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _reactAddonsShallowCompare2.default)(this, nextProps, nextState);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _echarts2.default.dispose(this.chart);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement('div', { ref: function ref(chart) {
          return _this2.chart = chart;
        }, className: this.props.className, style: this.props.style });
    }
  }]);

  return ECharts;
}(_react2.default.Component);

/**
 *
 * option: 图表的配置项和数据
 * notMerge: 可选，是否不跟之前设置的option进行合并，默认为false，即合并
 * lazyUpdate: 可选，在设置完option后是否不立即刷新画布，默认为false，即立即刷新
 * style: 图表容器的样式,默认高宽100%
 * config: 设置
 *    theme: 主题
 *    event: 事件
 *    showLoading: 是否呈现加载效果
 *    loadingOption: 加载效果设置
 * id: 图表id,可选
 */


ECharts.propTypes = {
  option: _propTypes2.default.object.isRequired,
  notMerge: _propTypes2.default.bool,
  lazyUpdate: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  className: _propTypes2.default.string,
  config: _propTypes2.default.object,
  id: _propTypes2.default.string
};

ECharts.defaultProps = {
  config: {},
  notMerge: false,
  lazyUpdate: false,
  style: {
    width: '100%',
    height: '100%'
  },
  id: 'chart'
};

exports.default = ECharts;